/***
*  Pivot.mq4
*  Pivot Calculator
*  Written by: CrushD
****/

#property indicator_chart_window
#property indicator_buffers 6

#property indicator_color1 Green
#property indicator_color2 Green
#property indicator_color3 Green
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_color6 Red

//---- input parameters\

extern string StartTime = "06:00";
extern string EndTime = "05:45";
double ch3, ch4, ch5, cl3,cl4, cl5;
//double x;
double pivotOpen=0;
double pivotHigh=0;
double pivotLow=0;
double pivotClose=0;
double D1=0.091667;
double D2=0.183333;
double D3=0.2750;
double D4=0.55;
bool pivotStarted=false;
bool pivotCompleted=false;
string Sup1="S 1", Res1="R 1", Res3="R 3";
string Sup2="S 2", Res2="R 2", Sup3="S 3";

// buffers
double CH3[];
double CH4[];
double CH5[];
double CL3[];
double CL4[];
double CL5[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
IndicatorShortName("Camarilla");

SetIndexStyle(0, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(0, CH3);

SetIndexStyle(1, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(1, CH4);

SetIndexStyle(2, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(2, CH5);

SetIndexStyle(3, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(3, CL3);

SetIndexStyle(4, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(4, CL4);

SetIndexStyle(5, DRAW_LINE, STYLE_SOLID);
SetIndexBuffer(5, CL5);

return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{  
   ObjectDelete("Sup1");
   ObjectDelete("Res1");
   ObjectDelete("Sup2");
   ObjectDelete("Res2");
   ObjectDelete("Sup3");
   ObjectDelete("Res3");   

return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{

//  int    counted_bars=IndicatorCounted();

//int limit;
//-------------------------------------------------------------------+
//---- indicator calculation
//-------------------------------------------------------------------+
//if (counted_bars==0)
//{
//   x=Period();
//   if (x>240) return(-1);
   
   ObjectCreate("Sup1", OBJ_ARROW, 0, 0, 0);
   ObjectSet("Sup1",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
   ObjectCreate("Res1", OBJ_ARROW, 0, 0, 0);
   ObjectSet("Res1",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
   ObjectCreate("Sup2", OBJ_ARROW, 0, 0, 0);
   ObjectSet("Sup2",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
   ObjectCreate("Res2", OBJ_ARROW, 0, 0, 0);
   ObjectSet("Res2",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
   ObjectCreate("Sup3", OBJ_ARROW, 0, 0, 0);
   ObjectSet("Sup3",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
   ObjectCreate("Res3", OBJ_ARROW, 0, 0, 0);
   ObjectSet("Res3",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
//}
//   if(counted_bars<0) return(-1);
   
   for(int i=Bars; i>=0; i--)
   {
      calcPivots(i);
      
      CL3[i] = cl3;
      CL4[i] = cl4;
      CL5[i] = cl5;
      CH3[i] = ch3;
      CH4[i] = ch4;
      CH5[i] = ch5;
   }
}

void calcPivots(int curBar)
{
   string barTime;
   
   barTime = TimeToStr(Time[curBar], TIME_MINUTES);
       
   if (barTime==StartTime)
   {
     pivotOpen = Open[curBar];
     pivotLow = Low[curBar];
     pivotHigh = High[curBar];
     pivotStarted=true;
   }

   if (pivotStarted && barTime==EndTime)
   {   
     pivotClose = Close[curBar];
     pivotCompleted=true; 
   }

   if (pivotStarted && pivotHigh<High[curBar])
   {
      pivotHigh=High[curBar];
   } 

   if (pivotStarted && pivotLow>Low[curBar]) 
   {
      pivotLow=Low[curBar];
   }  

   if (pivotCompleted)
   {
      ch5 = (pivotHigh/pivotLow)*pivotClose;
      ch4 = ((pivotHigh - pivotLow)* D4) + pivotClose;
      ch3 = ((pivotHigh - pivotLow)* D3) + pivotClose;
//ch2 = ((pivotHigh - pivotLow) * D2) + pivotClose;
//ch1 = ((pivotHigh - pivotLow) * D1) + pivotClose;

//cl1 = pivotClose - ((pivotHigh - pivotLow)*(D1));
//cl2 = pivotClose - ((pivotHigh - pivotLow)*(D2));
      cl3 = pivotClose - ((pivotHigh - pivotLow)*(D3));
      cl4 = pivotClose - ((pivotHigh - pivotLow)*(D4));     
      cl5 = pivotClose - (ch5 - pivotClose);
      
      pivotStarted = false;
      pivotCompleted = false; 
      
   ObjectMove("Sup1", 0, Time[0],ch3);
   ObjectMove("Res1", 0, Time[0],ch4);
   ObjectMove("Sup2", 0, Time[0],ch5);
   ObjectMove("Res2", 0, Time[0],cl3);
   ObjectMove("Sup3", 0, Time[0],cl4);
   ObjectMove("Res3", 0, Time[0],cl5); 
   }
   
   
}